# This file contains a JSONSchema to validate the values given
# as inputs to the chart.
#
# **** How to edit this file *****
#
# This file is encoded as YAML instead of JSON to allow comments,
# and make editing and diffing easier.
#
# The values.schema.json file is the file actually used by the Helm chart
# and MUST BE RECREATED after each modification of this file:
#
#   ./utils/_yaml2json.py < values.schema.yaml > values.schema.json
#
# You can test that this file is a valid JSONSchema with:
#
#   utils/_yaml2json.py < values.schema.yaml > values.schema.json && python -m jsonschema -o pretty /usr/lib/python3/dist-packages/jsonschema/schemas/draft2020-12.json -i values.schema.json
#
# **** How to test that values.yaml files conform to this schema ****
#
# Helm template will do this validation:
#
#  utils/_yaml2json.py < values.schema.yaml > values.schema.json && helm template . --values values.yaml
#
# You can also use another JSONSchema validation tool (it's useful to have more detailed answers than what Helm produces):
#
#   To test the chart default values.yaml:
#
#      utils/_yaml2json.py < values.schema.yaml > values.schema.json && \
#        utils/_yaml2json.py < values.yaml | python -m jsonschema -o pretty values.schema.json -i /dev/stdin
#
#   To test the combination of the default values.yaml combined with other values files:
#
#      utils/_yaml2json.py < values.schema.yaml > values.schema.json && \
#        utils/_yaml-merge.py -o json values.yaml foo.yaml | python -m jsonschema -o pretty values.schema.json -i /dev/stdin
#


$schema: https://json-schema.org/draft/2020-12/schema#

title: Schema for sylva-capi-cluster chart values

# this description is formatted so that it will appear very clearly
# in the JSON counterpart that the JSON isn't meant to be edited
description:
  ----------------------------------------------------------------------
  DO NOT EDIT THIS FILE AS JSON, THE YAML VERSION IS THE SOURCE OF TRUTH
  ----------------------------------------------------------------------
# sub-schemas used later on in the actual schema
$defs:
  ipv4-cidr:
    type: string
    pattern: ^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)(?:\/([1-9]|[12]\d|3[01]))$

  ipv4-cidr-full:
    type: string
    pattern: ^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)(?:\/([1-9]|[12]\d|3[012]))$

  ipv4-range:
    type: string
    pattern: ^(?:(?:[01]?[0-9]{1,2}|2[0-4][0-9]|25[0-5])\.){3}(?:[01]?[0-9]{1,2}|2[0-4][0-9]|25[0-5])-(?:(?:[01]?[0-9]{1,2}|2[0-4][0-9]|25[0-5])\.){3}(?:[01]?[0-9]{1,2}|2[0-4][0-9]|25[0-5])$

# lines with '# -------------------------------' correspond to keys in values.yaml
# (the rest being the JSONSchema language itself)

additionalProperties: false

# the default values.yaml covers all required keys, so in general
# no top-level key will be missing, this check is here only to
# cover the case where a user would mistakenly remove one of them by "nulling" it
# (e.g. by setting `proxies:` without any subdict in override values)
#required:

properties:
  name:  # -------------------------------
    type: string
  air_gapped:  # -------------------------------
    type: boolean
  cis_profile:  # -------------------------------
    anyOf:
      - type: string
        enum:
          - ""
          - cis-1.6
          - cis-1.23
  image:  # -------------------------------
    type: string
  worker_machine_image:  # -------------------------------
    type: string
  capi_providers:  # -------------------------------
    type: object
    additionalProperties: false
    properties:
      infra_provider:  # -------------------------------
        enum:
          - capd
          - capo
          - capv
          - capm3
      bootstrap_provider:  # -------------------------------
        enum:
          - cabpk
          - cabpr

  k8s_version:  # -------------------------------
    type: string

  control_plane_replicas:  # -------------------------------
    type: integer

  worker_replicas:  # -------------------------------
    type: integer

  cluster_services_cidrs:  # -------------------------------
    type: array
    items:
      $ref: "#/$defs/ipv4-cidr"

  cluster_pods_cidrs:  # -------------------------------
    type: array
    items:
      $ref: "#/$defs/ipv4-cidr"

  capd:  # -------------------------------
    type: object
    additionalProperties: false
    properties:
      docker_host_socket:  # -------------------------------
        type: string

  capo: # -------------------------------
    type: object

  capv: # -------------------------------
    type: object

  cluster_external_ip:  # -------------------------------
    type: string
    format: ipv4

  cluster_external_ip_interfaces:  # -------------------------------
    type: array
    items:
      type: string

  metallb_helm_oci_url: # -------------------------------
    anyOf:
      - type: string
        pattern: "^oci://.*"

  metallb_helm_version: # -------------------------------
    type: string

  capi_rancher_import:  # -------------------------------
    type: boolean

  enable_longhorn:
    type: boolean

  mgmt_cluster_external_ip:  # -------------------------------
    type: string
    format: ipv4

  mgmt_cluster_external_domain:  # -------------------------------
    type: string
    format: hostname

  ntp:  # -------------------------------
    type: object
    additionalProperties: false
    patternProperties:
      enabled:
        type: boolean
      servers:
        type: array
        items:
          anyOf:
            - type: string
              format: ipv4
            - type: string
              format: hostname

  proxies:  # -------------------------------
    type: object
    additionalProperties: false
    patternProperties:
      https?_proxy:  # -------------------------------
        type: string
        pattern: "^(https?://.*|)$"
      no_proxy:  # -------------------------------
        type: string
    required:
      - http_proxy
      - https_proxy
      - no_proxy

  registry_mirrors:  # -------------------------------
    type: object
    additionalProperties: false
    properties:
      default_settings:  # -------------------------------
        type: object
      hosts_config:  # -------------------------------
        type: object
        additionalProperties: false
        patternProperties:
          "^[a-z0-9][a-z0-9.-]*[a-z0-9]$":  # -------------------------------
            type: array
            items:
              type: object
              additionalProperties: false
              properties:
                registry_settings: # -------------------------------
                  type: object
                mirror_url:  # -------------------------------
                  type: string
                  format: uri
                  pattern: "^(https?://.*|)$"

  bgp_lbs:  # -------------------------------
    type: object
    additionalProperties: false
    properties:
      kube_vip:  # -------------------------------
        type: object
        additionalProperties: false
        properties:
          bgp_routerid:  # -------------------------------
            type: string
            format: ipv4
          bgp_routerinterface:  # -------------------------------
            type: string
          bgp_sourceif:  # -------------------------------
            type: string
          bgp_sourceip:  # -------------------------------
            type: string
            format: ipv4
          bgp_as:  # -------------------------------
            type: integer
          bgp_peers:  # -------------------------------
            type: string
          vip_cidr:  # -------------------------------
            type: integer
      metallb:  # -------------------------------
        type: object
        additionalProperties: false
        properties:
          address_pools: # -------------------------------
            type: array
            items:
              type: object
              required:
                - name
                - addresses
              properties:
                name: # -------------------------------
                  type: string
                addresses: # -------------------------------
                  type: array
                  items:
                    anyOf:
                      - $ref: "#/$defs/ipv4-cidr-full"
                      - $ref: "#/$defs/ipv4-range"
          l3_options: # -------------------------------
            type: object
            additionalProperties: false
            properties:
              bgp_peers: # -------------------------------
                type: array
                items:
                  type: object
                  required:
                    - name
                    - local_asn
                    - peer_asn
                    - peer_address
                  properties:
                    name: # -------------------------------
                      type: string
                    local_asn: # -------------------------------
                      type: integer
                      minimum: 1
                      maximum: 4294967295  # 2**32
                    peer_asn: # -------------------------------
                      type: integer
                      minimum: 1
                      maximum: 4294967295  # 2**32
                    peer_address: # -------------------------------
                      type: string
                      format: ipv4
                    advertised_pools: # -------------------------------
                      type: array
                      items:
                        type: string

  # TODO: add schema properties for default, control_plane, machine_deployment_default, machine_deployments, images and metal3 once we agree on the data structure format

  metal3: # -------------------------------
    type: object

  images: # -------------------------------
    type: object

  default: # -------------------------------
    type: object

  control_plane: # -------------------------------
    type: object

  machine_deployments: # -------------------------------
    type: object

  machine_deployment_default: # -------------------------------
    type: object

  baremetal_hosts: # -------------------------------
    type: object

  baremetal_host_default: # -------------------------------
    type: object

allOf:
  - if:
      properties:
        capi_providers:
          properties:
            infra_provider:
              const: capo
        worker_replicas:
          type: integer
          minimum: 1
    then:
      properties:
        capo:  # -------------------------------
          type: object
          properties:

            worker_az:  # -------------------------------
              type: string

          required:
            - worker_az
  - if:
      properties:
        capi_providers:
          properties:
            infra_provider:
              const: capo
    then:
      properties:
        capo:  # -------------------------------
          type: object
          additionalProperties: false
          properties:

            flavor_name:  # -------------------------------
              type: string

            worker_flavor_name:  # -------------------------------
              type: string

            control_plane_az:
              type: array
              items:
                type: string

            worker_az:  # -------------------------------
              type: string

            ssh_key_name:  # -------------------------------
              type: string

            network_id:  # -------------------------------
              type: string

            external_network_id:  # -------------------------------
              type: string

            additional_networks:  # -------------------------------
              type: object
              additionalProperties: false
              properties:
                virtio_network_id:
                  type: string
                direct_network_id:
                  type: string

            rootVolume:  # -------------------------------
              type: object
              additionalProperties: false
              properties:
                diskSize:  # -------------------------------
                  type: integer
                volumeType:  # -------------------------------
                  type: string

            control_plane_servergroup_id:  # -------------------------------
              type: string

            worker_servergroup_id:  # -------------------------------
              type: string

            control_plane_security_group_name:  # -------------------------------
              type: string

            worker_security_group_name:  # -------------------------------
              type: string

            clouds_yaml:  # -------------------------------
              type: object
              additionalProperties: false
              properties:

                clouds:  # -------------------------------
                  type: object
                  additionalProperties: false
                  required:
                    - capo_cloud
                  patternProperties:

                    "(capo_cloud|.*)":  # -------------------------------
                      type: object
                      additionalProperties: true
                      required:
                        - auth
                      properties:

                        auth:  # -------------------------------
                          type: object
                          additionalProperties: true
                          required:
                            - auth_url
                            - username
                            - password
                            - project_name
                            - project_domain_name
                            - user_domain_name
                          properties:
                            auth_url:  # -------------------------------
                              type: string
                              format: uri
                            user_domain_name:  # -------------------------------
                              type: string
                            project_domain_name:  # -------------------------------
                              type: string
                            project_name:  # -------------------------------
                              type: string
                            username:  # -------------------------------
                              type: string
                            password:  # -------------------------------
                              type: string
                        region_name:  # -------------------------------
                          anyOf:
                            - type: string
                            - type: "null"
                        verify:  # -------------------------------
                          type: boolean

            cacert:  # -------------------------------
              type: string

            resources_tag:  # -------------------------------
              type: string

  - if:
      properties:
        capi_providers:
          properties:
            infra_provider:
              const: capv
    then:
      properties:
        capv:  # -------------------------------
          type: object
          additionalProperties: false
          properties:

            dataCenter:  # -------------------------------
              type: string

            networks:  # -------------------------------
              type: object
              additionalProperties: true
              patternProperties:

                "^[a-z0-9][a-z0-9-]*[a-z0-9]$":
                  type: object
                  additionalProperties: false
                  properties:

                    dhcp4:
                      type: boolean
                    networkName:
                      type: string

                  required:
                    - networkName

            server:  # -------------------------------
              type: string

            dataStore:  # -------------------------------
              type: string

            tlsThumbprint:  # -------------------------------
              type: string

            username:  # -------------------------------
              type: string

            password:  # -------------------------------
              type: string

            ssh_key:  # -------------------------------
              type: string

            folder:  # -------------------------------
              type: string

            resourcePool:  # -------------------------------
              type: string

            storagePolicyName:  # -------------------------------
              type: string

            template_clone_mode:  # -------------------------------
              type: string
              enum:
                - "linkedClone"
                - "fullClone"

            control_plane_profile:  # -------------------------------
              type: object
              properties:

                diskGiB:  # -------------------------------
                  type: integer

                memoryMiB:  # -------------------------------
                  type: integer

                numCPUs:  # -------------------------------
                  type: integer

            storageClass:  # -------------------------------
              type: object
              properties:

                storagePolicyName:  # -------------------------------
                  type: string

                fsType:  # -------------------------------
                  type: string

  - if:
      properties:
        capi_rancher_import:
          const: true
      required:
        - capi_rancher_import
    then:
      required:
        - mgmt_cluster_external_ip  # -------------------------------
        - mgmt_cluster_external_domain  # -------------------------------
